• <ins id="pjuwb"></ins>
    <blockquote id="pjuwb"><pre id="pjuwb"></pre></blockquote>
    <noscript id="pjuwb"></noscript>
          <sup id="pjuwb"><pre id="pjuwb"></pre></sup>
            <dd id="pjuwb"></dd>
            <abbr id="pjuwb"></abbr>

            eryar

            PipeCAD - Plant Piping Design Software.
            RvmTranslator - Translate AVEVA RVM to OBJ, glTF, etc.
            posts - 603, comments - 590, trackbacks - 0, articles - 0

            OpenCASCADE中散亂Edge生成Wire

            Posted on 2018-05-20 21:50 eryar 閱讀(2201) 評論(0)  編輯 收藏 引用 所屬分類: 2.OpenCASCADE

            OpenCASCADE中散亂Edge生成Wire

            eryar@163.com

            Abstract. In OpenCASCADE a wire can be built from any number of edges in sequence. If edges are not in sequence, you must sort them in order.

            Key Words. Edge, Wire, Wire order

            1. Introduction

            在OpenCASCADE中生成WIRE時要求添加到WIRE中的邊EDGE是有順序要求的。當給定的邊沒有按順序添加到WIRE之前,需要自己將EDGE按順序處理。OpenCASCADE中也提供了對EDGE按順序進行排序的功能,方便WIRE的生成。

            本文給出將散亂的EDGE排序后生成WIRE的實現代碼,這個功能用處還是很大的。

            2. Code 

            在模型檢查模塊TKShHealing中,OpenCASCADE提供了類ShapeAnalysis_WireOrder用來將用于生成WIRE的一系列EDGE進行排序。這個類的實現原理是根據EDGE的起點、終點坐標來進行連接,生成順序。

            如下圖所示為一個封閉的WIRE,根據這些尺寸標注,生成WIRE的EDGE。

            wps_clip_image-18201

            實現上述Wire的程序代碼如下所示:

            /*
            The MIT License (MIT)
            ---------------------
            Copyright(C) 2018 Shing Liu(eryar@163.com)
            Permission is hereby granted, free of charge, to any person obtaining a copy
            of this software and associated documentation files(the "Software"), to deal
            in the Software without restriction, including without limitation the rights
            to use, copy, modify, merge, publish, distribute, sublicense, and / or sell
            copies of the Software, and to permit persons to whom the Software is
            furnished to do so, subject to the following conditions :
            The above copyright notice and this permission notice shall be included in all
            copies or substantial portions of the Software.
            THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
            IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
            FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
            AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
            LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
            OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
            SOFTWARE.
            */
            #include <vector>
            #include <gp_Pnt.hxx>
            #include <gp_Circ.hxx>
            #include <TopTools_ListOfShape.hxx>
            #include <BRep_Tool.hxx>
            #include <BRepTools.hxx>
            #include <BRepBuilderAPI_MakeEdge.hxx>
            #include <BRepBuilderAPI_MakeWire.hxx>
            #include <ShapeAnalysis_Edge.hxx>
            #include <ShapeAnalysis_WireOrder.hxx>
            #pragma comment(lib, "TKernel.lib")
            #pragma comment(lib, "TKMath.lib")
            #pragma comment(lib, "TKG2d.lib")
            #pragma comment(lib, "TKG3d.lib")
            #pragma comment(lib, "TKGeomBase.lib")
            #pragma comment(lib, "TKGeomAlgo.lib")
            #pragma comment(lib, "TKBRep.lib")
            #pragma comment(lib, "TKTopAlgo.lib")
            #pragma comment(lib, "TKShHealing.lib")
            void test(void)
            {
                std::vector<TopoDS_Edge> anEdges;
                // 5 Segment edges.
                BRepBuilderAPI_MakeEdge anEdgeMaker1(
                    gp_Pnt(-1650.0, 2857.88383249, 0.0),
                    gp_Pnt(-750.0, 1299.03810568, 0.0));
                BRepBuilderAPI_MakeEdge anEdgeMaker2(
                    gp_Pnt(1299.03810568, 750.0, 0.0),
                    gp_Pnt(2857.88383249, 1650.0, 0.0));
                BRepBuilderAPI_MakeEdge anEdgeMaker3(
                    gp_Pnt(2857.88383249, 1650.0, 0.0),
                    gp_Pnt(8000.0, 1650.0, 0.0));
                BRepBuilderAPI_MakeEdge anEdgeMaker4(
                    gp_Pnt(8000.0, 1650.0, 0.0),
                    gp_Pnt(8000.0, -3300.0, 0.0));
                BRepBuilderAPI_MakeEdge anEdgeMaker5(
                    gp_Pnt(8000.0, -3300.0, 0.0),
                    gp_Pnt(0.0, -3300.0, 0.0));
                anEdges.push_back(anEdgeMaker1.Edge());
                anEdges.push_back(anEdgeMaker2.Edge());
                anEdges.push_back(anEdgeMaker3.Edge());
                anEdges.push_back(anEdgeMaker4.Edge());
                anEdges.push_back(anEdgeMaker5.Edge());
                // 2 Arc edges.
                gp_Circ aCircle1(gp::XOY(), 1500.0);
                gp_Circ aCircle2(gp::XOY(), 3300.0);
                BRepBuilderAPI_MakeEdge anEdgeMaker6(aCircle1,
                    gp_Pnt(-750.0, 1299.03810568, 0.0),
                    gp_Pnt(1299.03810568, 750.0, 0.0));
                BRepBuilderAPI_MakeEdge anEdgeMaker7(aCircle2,
                    gp_Pnt(-1650.0, 2857.88383249, 0.0),
                    gp_Pnt(0.0, -3300.0, 0.0));
                anEdges.push_back(anEdgeMaker6.Edge());
                anEdges.push_back(anEdgeMaker7.Edge());
                // Get edges order for the wire.
                ShapeAnalysis_Edge anEdgeAnalyser;
                ShapeAnalysis_WireOrder aWireOrder;
                for (std::vector<TopoDS_Edge>::const_iterator i = anEdges.begin();
                    i != anEdges.end(); ++i)
                {
                    TopoDS_Vertex aVf = anEdgeAnalyser.FirstVertex(*i);
                    TopoDS_Vertex aVl = anEdgeAnalyser.LastVertex(*i);
                    gp_Pnt aPf = BRep_Tool::Pnt(aVf);
                    gp_Pnt aPl = BRep_Tool::Pnt(aVl);
                    aWireOrder.Add(aPf.XYZ(), aPl.XYZ());
                }
                // 
                TopTools_ListOfShape aOrderedEdges;
                for (Standard_Integer e = 1; e <= aWireOrder.NbEdges(); ++e)
                {
                    const TopoDS_Edge& anEdge = anEdges.at(e - 1);
                    aOrderedEdges.Append(anEdge);
                }
                BRepBuilderAPI_MakeWire aWireMaker;
                aWireMaker.Add(aOrderedEdges);
                if (aWireMaker.IsDone())
                {
                    BRepTools::Write(aWireMaker.Shape(), "d:/wire.brep");
                }
            }
            int main(int argc, char* argv[])
            {
                test();
                return 0;
            }

            程序先添加5條線段到EDGE數組,再添加兩個圓弧到EDGE數組。再使用類ShapeAnalysis_WireOrder來對EDGE數組進行排序,將排序后的EDGE數組去生成WIRE。如果生成WIRE成功,會在D盤得到一個wire.brep文件。在Draw中加載后顯示如下圖所示:

            wps_clip_image-1190

            生成WIRE后,繼而可以生成FACE,對FACE進行拉伸可以得到拉伸體,如下圖所示:

            wps_clip_image-9137

            3. Conclusion

            OpenCASCADE中生成WIRE時對添加的EDGE是有順序的要求。如何對散亂的EDGE進行排序以達到生成WIRE的要求呢?OpenCASCADE在TKShHealing模塊中提供了對EDGE排序的功能。

            對EDGE排序的功能原理很簡單,就是將所有的EDGE首尾相連,感興趣的讀者可以結合源碼學習下。



            為了方便大家在移動端也能看到我的博文和討論交流,現已注冊微信公眾號,歡迎大家掃描下方二維碼關注。
            Shing Liu(eryar@163.com)

             

            久久精品国产免费观看三人同眠| 亚洲国产另类久久久精品小说| 久久国产欧美日韩精品| 久久精品亚洲一区二区三区浴池| 亚洲成色www久久网站夜月| 国产精品久久久久影视不卡| 久久亚洲国产午夜精品理论片| 久久播电影网| 欧美噜噜久久久XXX| 久久亚洲精品无码播放| 日韩精品久久久久久久电影蜜臀 | 久久久久久综合一区中文字幕 | 草草久久久无码国产专区| 久久久久九九精品影院| 久久婷婷五月综合97色一本一本 | 国产亚洲成人久久| 久久狠狠爱亚洲综合影院| 色综合久久久久| 久久乐国产综合亚洲精品| 精品免费tv久久久久久久| 精品久久久久久久国产潘金莲| 99久久99久久精品国产| 久久综合给合久久狠狠狠97色| 久久人人爽人人澡人人高潮AV| 99久久国产热无码精品免费| 久久精品国产免费观看三人同眠| 久久青青草原精品国产软件| AAA级久久久精品无码片| 久久九九兔免费精品6| 免费一级欧美大片久久网| 66精品综合久久久久久久| 国产精品久久久久9999| 久久人人爽人人爽人人AV| 欧美一级久久久久久久大片| 久久精品?ⅴ无码中文字幕| 色综合色天天久久婷婷基地| A狠狠久久蜜臀婷色中文网| av无码久久久久久不卡网站| 国产精品免费看久久久 | 国产99久久久久久免费看| 国产精品禁18久久久夂久|